#include "StdAfx.h"
#include "ListBoxPropertyAccessor.h"

#include "ScriptletConstant.h"
#include "ListBox.h"

REGISTER_PROPERTY_ACCESSOR(SCRIPTLET_LISTBOX_NODE, ListBoxPropertyAccessor)
BOOL ListBoxPropertyAccessor::SetProperty(CComponent* pTarget, LPCTSTR property, CComVariant value)
{
	BOOL bSuccess = __super::SetProperty(pTarget, property, value);
	if (bSuccess == FALSE)
	{
		CListBox* listbox = dynamic_cast<CListBox*>(pTarget);
		if (listbox == NULL) return bSuccess;

		USES_CONVERSION;
		//additem
		if (_tcsicmp(SCRIPTLET_ADDITEM_NODE, property) == 0)
		{
			listbox->AddItem(listbox->GetDataContext(), value.intVal);
			listbox->RecalcLayout();
			listbox->Invalidate();
			bSuccess = TRUE;
		}
		//removeitem
		else if (_tcsicmp(SCRIPTLET_REMOVEITEM_NODE, property) == 0)
		{
			listbox->RemoveItem(value.intVal);
			listbox->RecalcLayout();
			listbox->Invalidate();
			bSuccess = TRUE;
		}
		//default select
		else if (_tcsicmp(SCRIPTLET_DEFAULT_SELECT_NODE, property) == 0)
		{
			listbox->Select(value.intVal);
			listbox->RecalcLayout();
			listbox->Invalidate();
			bSuccess = TRUE;
		}

	}
	return bSuccess;
}
BOOL ListBoxPropertyAccessor::GetProperty(CComponent* pTarget, LPCTSTR property, CComVariant& value)
{
	BOOL bSuccess = __super::GetProperty(pTarget, property, value);
	if (bSuccess == FALSE)
	{
		CListBox* listbox = dynamic_cast<CListBox*>(pTarget);
		if (listbox == NULL) return bSuccess;
	}
	return bSuccess;
}